/*
 *	ohb̐̃I}P̃[_[łB
 *
 *	X68K15rbgFT|[gĂȂ̂ł܂ł
 *	PIC𗝉I}PƂčlĂB
 *      ܂X68Kł܂B
 *
 *	Ȃint16bitłAvłBlong32bitKvłB
 *
 *@@@܂A_ێ̂ɁAVRAM̐F(16bit)LSBtO
 *	ƂĎgpĂ܂B
 *	Ȃ݂ɂ̕@ƘAp̃obt@xx16bit邯
 *	HvƂƏȂčς݂܂B̃\[X邯(98p)
 *	₷̖ʂŁÂǂł傤B
 */
#include	<stdio.h>
#include	<sys/fcntl.h>

#define		SIZE_OF_X 512		/* ʂ̕		*/
#define		SIZE_OF_Y 512		/* ʂ̍		*/

#define		SIZE_OF_BUFF 2048	/* t@Cobt@̃TCY	*/

int	handle;			/* ჌xt@C̃nh		*/
int	bit_len;		/* rbgobt@̃rbg		*/
char	*buff_p;		/* t@Cobt@̃|C^		*/
int	buff_len;		/* t@Cobt@̎cf[^	*/
char	buff[SIZE_OF_BUFF];	/* t@Cobt@			*/
int	x_wid,y_wid;		/* ohbf[^̉摜TCY		*/

struct	{			/* FLbV悤 */
	int	color;
	int	next;
	int	prev;
}	table[128];
int	color_p;		/* FLbV̍ŐVFw		*/


/*
 * G[Eo
 */
void
error( char *s)
{
	puts(s);
	exit(1);
}


/*
 * int c = point(int x,int y)
 * (x,y) ̃J[R[hԂ֐
 *
 * x : screen X ( 0 .. SIZE_OF_X - 1)
 * y : screen Y ( 0 .. SIZE_OF_Y - 1)
 * c : color code 16bit
 *		0	: bright
 *		1..5	: blue
 *		6..10	: red
 *		11..15	: green
 */

/*
 * void pset(int x,int y,int c)
 * (x, y)WɐFc֐
 *
 * x : screen X ( 0 .. SIZE_OF_X - 1)
 * y : screen Y ( 0 .. SIZE_OF_Y - 1)
 * c : color code 16bit
 *		0	: bright
 *		1..5	: blue
 *		6..10	: red		
 *		11..15	: green
 */

/*
 * OtBbN̉ʂݒ肵āANA֐
 */
void
ginit( void)
{
	C_WIDTH(5);	/* x68k 512x512 65536 */
}


/*
 * obt@PoCgrbgobt@ɓǂݍ
 */
void
buff_next( void)
{
	if ( buff_len == 0 ) {
		if ( (buff_len = read( handle, buff, SIZE_OF_BUFF )) == 0 ) {
			error("file read error");
		}
		buff_p = buff;
	} else {
		buff_p++;
	}
	buff_len--;
	bit_len = 8;
}


/*
 * sizerbgǂݍ
 */
long
bit_load( int size)
{
	int	i;
	long	a;
	
	a = 0;
	while ( size > bit_len ) {
		for ( i = 0; i < bit_len; i++ ) {
			a = a + a;
			if ( *buff_p & 0x80 ) a++;
			*buff_p = *buff_p + *buff_p;
			size--;
		}
		buff_next();
	}
	for ( i = 0; i < size; i++ ) {
		a = a + a;
		if ( *buff_p & 0x80 ) a++;
		*buff_p = *buff_p + *buff_p;
		bit_len--;
	}
	return ( a);
}


/*
 * FLbV̏
 */
void
color_cash_init( void)
{
	int	i;
	
	for ( i = 0; i < 128; i++ ) {
		table[i].color = 0;
		table[i].prev = i + 1;
		table[i].next = i - 1;
	}
	table[127].prev = 0;
	table[0].next = 127;
	color_p = 0;
}

/*
 * LbVFo
 * ̐FŐVɂȂ悤ɍXVB
 */
int
get_color( int idx)
{
	if ( color_p != idx ) {
		/* ܂ʒuidxLbV؂藣 */
		table[table[idx].prev].next = table[idx].next;
		table[table[idx].next].prev = table[idx].prev;
		/* ŐVF̎idxVɃZbg */
		table[table[color_p].prev].next = idx;
		table[idx].prev = table[color_p].prev;
		table[color_p].prev = idx;
		table[idx].next = color_p;
		/* ŐVFʒuXV */
		color_p = idx;
	}
	/* Q{̂́ALbVɓĂF bit0..14 
	 * ̂ bit1..15 
	 */
	return ( table[idx].color * 2);
}


/*
 *  VFLbVɓo^
 */
int
new_color( int c)
{
	color_p = table[color_p].prev;
	table[color_p].color = c;
	return ( c << 1);
}

/*
 * F̓ǂݍ
 */
int
read_color( void)
{
	if ( bit_load(1) == 0 ) {
		/* LbV~X */
		return ( new_color( bit_load(15)));
	} else {
		/* LbVqbg */
		return ( get_color( bit_load(7)));
	}
}


/*
 * ̓ǂݍ
 */
long
read_len( void)
{
	int	a;
	
	a = 1;
	while ( bit_load(1) != 0 ) {
		a++;
	}
	return ( bit_load(a) + (1 << a) - 1);
}


/*
 * A̓WJ
 */
void
expand_chain( int x,int y,int c)
{
	int	y_over;	/* 摜TCYʃTCY𒴂̃tO */

	y_over = 0;	/* ܂ĂȂ */

	for ( ;; ) {
		switch ( bit_load(2) ) {
			case 0:	if ( bit_load(1) == 0 ) return; /* I */
				if ( bit_load(1) == 0 ) x -= 2; /* Q */
				else x += 2;	/* EQ */
				break;
			case 1:	x--; break;	/* P */
			case 2:      break;	/* ^   */
			case 3: x++; break;     /* EP */
		}
		if ( ++y >= y_wid ) y_over = 1;	/* ʂ𒴂 */

		/* ʂ𒴂ĂȂ̂ȂA
		 * " | 1"̂ c=0 ̎ɂAƔ悤
                 */
		if ( y_over == 0) pset(x, y, c | 1);
	}
}


/*
 *  WJ邼
 */
void
expand( void)
{
	int	x;	/* WJ̈ʒu X */
	int	y;	/* WJ̈ʒu Y */
	int	c;	/* ݂̐F	  */
	long	l;	/* ω_Ԃ̒ */
	int	a;

	x = -1;
	y = 0;
	c = 0;		/* F̏l 0 */
	for ( ;; ) {
		l = read_len(); /* ǂݍ */

		/* ̕ω_܂ŌJԂ */
		while ( --l ) {
			/* E[̏ */
			if ( ++x == x_wid ) {
				if( ++y == y_wid ) return; /* (^_^;) */
				x = 0;
			}
			/* A_ʉ߂́A݂̐FύX */
			if ( ( a = point(x, y)) != 0 ) {
				c = a & 0xfffe;
			}
			/* ݂̐F */
			pset(x, y, c);
		}
		/* E[̏ */
		if ( ++x == x_wid ) {
			if( ++y == y_wid ) return; /* (^_^;) */
			x = 0;
		}
		/* VF̓ǂݍ */
		c = read_color();

		/*  */
		pset(x, y, c);

		/* AȂAA̓WJ */
		if ( bit_load(1) != 0) expand_chain(x, y, c);
	}
}

/*
 * wb_݂̂
 */
void
header_read( void)
{
	int	c;

	if ( bit_load( 8) != 'P' ) error("picł͂܂");
	if ( bit_load( 8) != 'I' ) error("picł͂܂");
	if ( bit_load( 8) != 'C' ) error("picł͂܂");
	while ( (c = bit_load( 8)) != 26 ) {
		putchar(c);	/*@Rg̕\ */
	}
	while ( bit_load( 8) != 0 ) /* ͓ǂݔ΂ */
	;	/* null loop */

	/*  0 ̂͂ */
	if ( bit_load( 8) != 0) error("picł͂܂");

	/* ^Cv/[hƂ 0ΉĂȂ */
	if ( bit_load( 8) != 0 ) error("߂ˑΉĂȂ");

	/* 15bitFΉĂȂ */
	if ( bit_load( 16) != 15 ) error("߂ˑΉĂȂ");
	if (( x_wid = bit_load( 16)) > SIZE_OF_X ) error("傫ēǂ߂Ȃ");
	if (( y_wid = bit_load( 16)) > SIZE_OF_Y ) {
		y_wid = SIZE_OF_Y;	/* Yɂ́Aʕ͓ǂ߂ */
	}
}

/*
 * CvO
 */
void
main( int argc, char *argv[])
{
	puts("PIC loader ver 0.01 by Ȃ");
	if ( argc != 2 ) error ("usage : PICL <file>");
	if ( (handle = open(argv[1], O_RDONLY | O_BINARY )) < 0 ) {
		error("t@CI[vłȂ");
	}
	bit_len = buff_len = 0;		/* t@Cobt@̏	*/
	ginit();			/* ʃ[h̏		*/
	color_cash_init();		/* FLbV		*/
	header_read();			/* wb_̓ǂݍ		*/
	expand();			/* WJ				*/
}


